'***************************************************************************
'
'ATTiny13 12 Charlieplexed Leds on PB 0 1 2 3
'
'
' input on ADC channel 2
'
'***************************************************************************
'  This program is free software; you can redistribute it and/or
'  modify it under the terms of the GNU General Public License.
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY;
'
'***************************************************************************
'
'  Pinout ATtiny13/ATtiny13V   8-PDIP/SOIC
'
' (PCINT5/RESET/ADC0/dW)   PB5 VCC
' (PCINT3/CLKI/ADC3)       PB3 PB2 (SCK/ADC1/T0/PCINT2)
' (PCINT4/ADC2)            PB4 PB1 (MISO/AIN1/OC0B/INT0/PCINT1)
'                          GND PB0 (MOSI/AIN0/OC0A/PCINT0)
'
'***************************************************************************
' PB0 output  Led
' PB1 output
' PB2 output
' PB3 output
' PB4 input   ADC channel 2
'***************************************************************************

$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 8
$swstack = 8
$framesize = 4

Const C_value = 187 - 1                                     ' Compare Match IRQ 10 ms
Declare Sub Mydelay


Dim Voltage As Word , Avgv As Word
Dim Icnt0 As Byte
Dim N As Byte , Xp As Byte , Xd As Byte
'Dim Pp As Byte , Dd As Byte

Portb = &B00000000
Ddrb = &B00000000

Acsr.acd = 1                                                ' switch off analog comparator

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Didr0.adc2d = 1
Start Adc

Config Timer0 = Timer , Prescale = 64
Ocr0a = C_value                                             ' value for 1.2 MHz
Tccr0a = &B00000010                                         ' ctc
Timsk0.ocie0a = 1
On Oc0a Tim0_compa
Start Timer0



For N = 0 To 11                                             'test leds
   Xd = Lookup(n , Led12)
   Xp = Xd
   Shift Xd , Right , 4                                     ' upper is DDR
   Xd = Xd And &H0F
   Xp = Xp And &H0F                                         ' lower is Port
   Portb = Xp
   Ddrb = Xd
   Call Mydelay
Next N

Enable Interrupts

Timer0 = 0

Do                                                          ' main loop

Loop


'***************************************************************************
'Tim0_compa Interrupt  10 ms
'***************************************************************************

Tim0_compa:                                                 '

  'Incr Icnt0
   Voltage = Getadc(2)
   Avgv = Getadc(2)
   Voltage = Avgv + Voltage
   N = Voltage / 170
   If N = 12 Then
    N = 11
   End If

   Xd = Lookup(n , Led12)
   Xp = Xd
   Shift Xd , Right , 4                                     ' upper is DDR
   Xd = Xd And &H0F
   Xp = Xp And &H0F                                         ' lower is Port
   Portb = Xp
   Ddrb = Xd


    'Voltage = Getadc(2)
    'Avgv = Avgv + Voltage
    'Shift Voltage , Right , 2                               '8 bit

Return

End

Mydelay:                                                    'delay
$asm
   PUSH R27
   Ldi R27 , 200                                            'Load R27
Mdec:
   Dec R27
   BRNE Mdec
   POP R27
$end Asm

Return


Led12:                                                      ' Led0..11 Cplex ' 12 = 0 upper 4 bit DDRB lower 4 bit PORTB


Data &B00110001 , &B11001000 , &B11000100 , &B10101000 , &B10100010 , &B01100100 , &B01100010 , &B01010100 , &B01010001 , &B10011000 , &B10010001 , &B00110010 , 0 , 0

